with import (builtins.fetchGit {
  name = "nixos-21.05-2021-08-02";
  url = "https://github.com/nixos/nixpkgs/";
  ref = "refs/heads/nixos-21.05";
  rev = "d4590d21006387dcb190c516724cb1e41c0f8fdf";
}) {};

python38Packages.buildPythonApplication rec {
  pname = "todo";
  version = "0.1.0";

  src = ./.;

  buildInputs = [
    qt5.qtwayland
    sqlite
  ];

  propagatedBuildInputs = with python38Packages; [
    pyqt5
    pytest
  ];

  makeWrapperArgs = [
    "--set QT_QPA_PLATFORM_PLUGIN_PATH ${qt5.qtwayland.bin}/lib/qt-*/plugins/platforms"
    "--set QT_PLUGIN_PATH ${qt5.qtwayland.bin}/lib/qt-*/plugins"
  ];

  shellHook = ''
    export QT_QPA_PLATFORM_PLUGIN_PATH="$(echo ${qt5.qtwayland.bin}/lib/qt-*/plugins/platforms)"
    export QT_PLUGIN_PATH="$(echo ${qt5.qtwayland.bin}/lib/qt-*/plugins)"
    export PYTHONPATH=./:$PYTHONPATH # Give access to kiosk_browser module
  '';
}
